# Control of solid-state nuclear spin qubits using an electron spin-1/2

This repository contains the data and simulations underlying the following publication:
**Title**: "Control of solid-state nuclear spin qubits using an electron spin-1/2" 
**Authors**: Hans K. C. Beukers, Christopher Waas, Matteo Pasini, Hendrik B. van Ommen, Zarije Ademi, Mariagrazia Iuliano, Nina Codreanu, Julia M. Brevoord, Tim Turan, Tim H. Taminiau and Ronald Hanson
**DOI**: 10.48550/arXiv:2409.08977

## Structure

The repository has the following structure:
**bin**: executables simplifying uploading to overleaf and exporting from Adobe InDesign.
**data**: The measurement data
**data_results**: The data generated by simulations or fits
**data_values**: Export of all values used in the paper
**figures**: InDesign and PDF files of the figures
**src/snvc**: Codebase used by the notebooks, for simulating, data handling and plotting.
**subfigures**: the subfigures used by the figures, these include the SVG exports as well as the InDesign and Illustrator files. 

The Makefile includes the instructions on how to run the code in the repository, it takes care of running of the notebooks and exporting the PDFs from InDesign. The simulations can be generated with the Makefile but are not included in "make all" as they take a considerable amount of time to run.

To make the link with Overleaf work, you have to clone the git repository from overleaf and put it in the same place as this repository. The name should be 'overleaf_nuclear_spin_snv'.

## How to get started

To make this repo you need uv [installed](https://docs.astral.sh/uv/getting-started/installation/).
This was tested with uv version 0.4.12.

To make the repo run install uv and clone the repo.

The makefile uses uv, so if you use that it should work out of the box.
For running specific commands in the virtual environment use:

```shell
uv run <command>
```

This should be enough to set everything up, including python version.