// Specify the path to the INDD file
var inddFilePath = "";

// Define the export options for PDF
app.pdfExportPreferences.pageRange = PageRange.ALL_PAGES; // Export all pages
app.pdfExportPreferences.viewPDF = false; // Don't view the PDF after export

var oldUserInteractionLevel = app.scriptPreferences.userInteractionLevel;
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.NEVER_INTERACT;

// Check if the file exists
var inddFile = new File(inddFilePath);
if (inddFile.exists && inddFile instanceof File) {
    // Open the INDD file
    var doc = app.open(inddFile);
    
    // Update linked images
    var linkImages = doc.links;
    for (var i = 0; i < linkImages.length; i++) {
        linkImages[i].update();
    }
    
    // Export the document to PDF format
    var pdfName = doc.name.replace(/\.indd$/i, "") + ".pdf";
    var pdfFile = new File(inddFile.parent + "/" + pdfName);
    doc.exportFile(ExportFormat.PDF_TYPE, pdfFile, false);
    
    // Close the document without saving changes
    doc.close(SaveOptions.YES);
} else {
    alert("The specified INDD file does not exist.");
}

app.scriptPreferences.userInteractionLevel = oldUserInteractionLevel;