#!/bin/zsh

# Define the path to the Git repository
repository_path="../overleaf_nuclear_spin_snv"
current_dir=$(pwd)

# Change directory to the repository path
cd "$repository_path" || exit

# Pull the latest changes from the remote repository
git pull

# Change directory to the current repository path
cd "$current_dir" || exit

cp figures/figure*.pdf ../overleaf_nuclear_spin_snv/

# Change directory to the repository path
cd "$repository_path" || exit

# Add all files starting with "figure"
git add figure*

# Commit the changes
git commit -m "Update figures"

# Push the changes to the remote repository
git push
