import numpy as np


def sinc(x):
    return np.sinc(x / np.pi)


def Omega_tilde(w0, w1, tau, wrf, Omega):
    Delta0 = w0 - wrf
    Delta1 = w1 - wrf
    return Omega * (sinc(Delta1 * tau) - sinc(Delta0 * tau))


def phase_update(wavg, wrf, tau):
    return (wavg - wrf) * 2 * tau + np.pi


def one_min_n0n1(Omega, Delta1):
    return 2 / (1 + Delta1**2 / Omega**2)


def Delta1_tilde(Delta0, Delta1, phase_update, tau, k):
    return Delta0 + Delta1 + (-phase_update + (2 * k + 1) * np.pi) / tau


def sigma_z(Omega, wrf, wavg, w0, w1, tau, N, k=0):
    Omega_tilde_ = Omega_tilde(w0, w1, tau, wrf, Omega)
    Delta0 = w0 - wrf
    Delta1 = w1 - wrf
    phase_update_ = phase_update(wavg, wrf, tau)
    Delta1_tilde_ = Delta1_tilde(Delta0, Delta1, phase_update_, tau, k)
    one_min_n0n1_ = one_min_n0n1(Omega_tilde_, Delta1_tilde_)
    return (
        1
        - one_min_n0n1_
        * np.sin(N * tau / 2 * np.sqrt(Omega_tilde_**2 + Delta1_tilde_**2)) ** 2
    )


def sigma_z_old(Omega, wrf, w0, w1, tau, N):
    Omega_tilde_ = Omega_tilde(w0, w1, tau, wrf, Omega)
    return 1 - 2 * np.sin(N * Omega_tilde_ * tau / 2) ** 2


def N_gate(w0, w1, tau, wrf, Omega):
    Omega_tilde_ = Omega_tilde(w0, w1, tau, wrf, Omega)
    return np.pi / (2 * Omega_tilde_ * tau)


def Omega_gate(w0, w1, tau, N, wrf):
    factor = Omega_tilde(w0, w1, tau, wrf, Omega=1)
    return np.pi / (2 * tau * factor * N)
